require("luamods/command")
require("luamods/layout")
require("luamods/cgi")
require("config/rsm_conf")
require("luamods/rsm_serials")

header = layout.getHeader()
footer = layout.getFooter()

userLevel = db.getPriv(layout.username) or 1

if (userLevel == 1) then
    buttonControl = " disabled"
    inputControl = " readonly"
else
    buttonControl = ""
    inputControl = ""
end

-- Little helper to prevent restarts, ups, downs, etc. if MDD restarts
-- are locked.
local pl_file = require('pl.file')
local function if_unlocked(action)
    local _, err = pl_file.read(rsm_conf.mdd_restart_lock)
    if err then -- file's not there, we will allow the action.
        action()
    end
end

config = command.ex([[cat ]]..rsm_conf.mdd_xml_path) or ""
templatesFiles = {}
if (config ~= "") then
    modbusPath = config:match([[<path%s+name=%"devices%"%s->(.-)</path>]]) or ""
    templatesPath = config:match([[<path%s+name=%"templates%"%s->(.-)</path>]]) or ""
    if (templatesPath ~= "") then
        templatesFiles = command.getFilesInTable(templatesPath)
    end
end

if (cgi.post.deleteButton == "Delete Device") and (userLevel ~= 1) then
    
    if_unlocked(function () 
        command.ex(rsm_conf.mdd_down)
    end)
    
    file = cgi.post.file or ""
    file = file:gsub("[^%w%.]+","")
    
    command.ex([[rm ]]..modbusPath..[[/]]..file)

    if_unlocked(function () 
        command.ex(rsm_conf.mdd_up)
    end)
    
    label = cgi.post.label or "unknown"
    bus = cgi.post.bus or "unknown"
    -- Stop here
    content = [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Edit Modbus TCP Device</h1></center>
                        </div>
                    </div>
                    <div id="info">
                        <center>
                            <h2><img src="images/ok.png"/> Device Deleted</h2>
                            Device with filename "]]..file..[[" has been removed.<br><br>
                            <a href="rsm_bus_config.lua">Back to Bus Configuration</a>
                        </center>
                    </div>
]]
    print(header..content..footer)
    os.exit()
end

if (cgi.post.saveButton == "Save and Apply") and (userLevel ~= 1) then
    newFile = cgi.post.file or ""
    newFile = newFile:gsub("[^%w%.]+","")
    if (newFile == "") then
        newSerial = rsm_serials.generateNewSerial()
        newFile = newSerial..".xml"
        createdNew = 1
    else
        createdNew = 0
        existingCfg = command.ex([[cat ]]..modbusPath..[[/]]..newFile)
        newSerial = existingCfg:match([[<serial>%s-(.-)%s-</serial>]])
        if (newSerial == nil) then
            -- Bail on error
            content = [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Edit Modbus TCP Device</h1></center>
                        </div>
                    </div>                  
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Filename / serial mismatch</h2>
                            The serial number of the device does not match the one in the file.<br>
                            <a href="rsm_bus_config.lua">Back to Bus Configuration</a>
                        </center>
                    </div>
]]
            print(header..content..footer)
            os.exit()
        end
    end
    newLabel = cgi.post.label or "unknown"
    newTemplate = cgi.post.template or "unknown"
    newHost = cgi.post.host or "unknown"
    newPort = cgi.post.port or "unknown"
    newSlave = cgi.post.slave or "2c"
    newXML = [[
<!-- ]]..modbusPath..[[/]]..newFile..[[ generated by webconfig -->
<device>
    <label>]]..newLabel..[[</label>
    <serial>]]..newSerial..[[</serial>
    <template>]]..newTemplate..[[</template>
    <tcpport>
        <host>]]..newHost..[[</host>
        <port>]]..newPort..[[</port>
        <slave>]]..newSlave..[[</slave>
    </tcpport>
</device>
<!-- end of file -->
]]
    if_unlocked(function ()
        command.ex(rsm_conf.mdd_down)
    end)
    command.writefile(modbusPath..[[/]]..newFile, newXML)
    if_unlocked(function ()
        command.ex(rsm_conf.mdd_up)
    end)
    filename = newFile
    saved = 1
    mode = "edit"
else
    filename = cgi.get.file or ""
    if (filename == "") then 
        mode = "new"
    else 
        filename = filename:gsub("[^%w%.]+","")
        mode = "edit"
    end
end    

if (mode == "edit") then
    
    cfg = command.ex([[cat ]]..modbusPath..[[/]]..filename) or ""
    if (cfg:match("<device>(.+)</device>") == nil) then
        -- bail on error
        content = [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Edit Modbus TCP Device</h1></center>
                        </div>
                    </div>            
                    <div id="info">
                        <center>
                            <h2><img src="images/warning.png"/> Invalid file</h2>
                            The specified file does not appear to be a valid Modbus TCP file.<br><br>
                            <a href="rsm_bus_config.lua">Back to bus configuration</a>
                        </center>
                    </div>
]]
        print(header..content..footer)
        os.exit()
    else
        d = {}
        d.label = cfg:match([[<label>%s-(.-)%s-</label>]]) or "unknown"
        d.serial = cfg:match([[<serial>%s-(.-)%s-</serial>]]) or "unknown"
        d.template = cfg:match([[<template>%s-(.-)%s-</template>]]) or "unknown"
        d.host = cfg:match([[<host>%s-(.-)%s-</host>]]) or "unknown"
        d.port = cfg:match([[<port>%s-(.-)%s-</port>]]) or "502" 
        d.slave = cfg:match([[<slave>%s-(.-)%s-</slave>]]) or "1" 
    end
else
    d = {}
    d.label = ""
    d.serial = "(unassigned)"
    d.template = ""
    d.host = ""
    d.port = "502"
    d.slave = "1"
end

templatesOptions = [[
    <option disabled ]] if (mode == "new") then templatesOptions = templatesOptions..[[selected]] end templatesOptions = templatesOptions..[[>Select a template</option>
]]

foundTemplate = 0
if (#(templatesFiles) > 0) then
    for i,f in pairs(templatesFiles) do
        templateXML = command.ex("cat "..templatesPath..[[/]]..f)
        make = templateXML:match("<make>%s-(.-)%s-</make>") or "?"
        mType = templateXML:match("<type>%s-(.-)%s-</type>") or "Unknown"
        version = templateXML:match("<version>%s-(.-)%s-</version>") or ""
        if (version ~= "") then version = "("..version..")" end
        templatesOptions = templatesOptions..[[
            <option value="]]..f..[["]] if f == d.template then templatesOptions = templatesOptions .. [[ selected ]] foundTemplate = 1 end templatesOptions = templatesOptions..[[>]]..make..[[ ]]..mType.." "..version..[[</option>
]]            
    end
else
        templatesOptions = [[
                                        <option disabled selected>No templates found</option>
]]
    foundTemplate = 1 -- Yeah this looks like it doesn't make sense, but it does
end
if (foundTemplate == 0) and (mode ~= "new") then
    templatesOptions = templatesOptions .. [[
                                        <option value="]]..d.template..[[" selected title="Template not found!">Template not found (]]..d.template..[[)</template>
]]        
end

content = ""

if (mode == "new") then
    content = content .. [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Add New Modbus TCP Device</h1></center>
                        </div>
                    </div>
]]
else
    content = content .. [[
                    <div id="info">
                        <div style="background:url(images/busconfig.png); background-size:32px; background-repeat:no-repeat; background-position: 20px center;">
                            <center><h1>Edit Modbus TCP Device</h1></center>
                        </div>
                    </div>
                    <h3>Editing device "]]..d.label..[[" with filename "]]..filename..[[" :</h3>
]]    
end

if (userLevel == 1) then
    content = content .. [[
                    <center><b>Note:</b> Editing this section requires administrator privileges.</center><br>
]]
end

content = content .. [[
 <script>
                        var doValidate = 0;
                        function validateForm(form)
                        {
                            
                            if (form.getAttribute('submitted')) return false;
                            
                            if (!doValidate)
                            {
                                form.setAttribute('submitted','true');
                                return true;
                            }
                            doValidate = 0;
                            
                            var inputs = form.getElementsByTagName("input");
                            
                            var loop;
                            var errors = 0;
                            for (loop = 0; loop < 2; loop++)
                            {
                                var warning = document.getElementById("warning"+loop);
                                if (inputs[loop].value == "")
                                {
                                    if (!warning)
                                    {
                                        warning = document.createElement("span");
                                        warning.id = "warning"+loop;
                                        warning.innerHTML = " <img src='images/warning.png' alt='Cannot be blank' title='Cannot be blank'/>";
                                        inputs[loop].parentNode.appendChild(warning);
                                    }
                                    errors++;
                                }
                                else
                                {
                                    if (warning)
                                    {
                                        warning.parentNode.removeChild(warning);
                                    }
                                }
                            }
                            
                            var template = document.getElementById("template");
                            warning = document.getElementById("templatewarning");                            
                            if (template.value == "Select a template")
                            {
                                if (!warning)
                                {
                                    warning = document.createElement("span");
                                    warning.id = "templatewarning";
                                    warning.innerHTML = " <img src='images/warning.png' alt='Choose a valid template' title='Choose a valid template'/>";
                                    template.parentNode.appendChild(warning);
                                }
                                errors++;
                            }
                            else
                            {
                                if (warning)
                                {
                                    warning.parentNode.removeChild(warning);
                                }
                            }
                            
                            if (errors)
                            {
                                alert("Not all fields have been filled in.\nPlease enter/select valid values for the indicated fields.");
                                return false;
                            }
                            else
                            {
                                form.setAttribute('submitted','true');
                                return true;
                            }
                        }
                    
                    </script>    

                    <form action="rsm_modbus_tcp_edit.lua" method="post" onsubmit="return validateForm(this);">
                        <div class="formLayoutfull">
                            <table class="onetwo">
                                <tr>
                                    <td style="padding: 5px;" width="30%">
                                        <b>Device Label:</b>
                                    </td>
                                    <td style="padding: 5px;" width="70%">
                                        <input type="text" name="label" value="]]..d.label..[["]]..inputControl..[[/>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Device Serial:</b>
                                    </td>
                                    <td style="padding: 5px;">]]..d.serial..[[</td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Template File:</b>
                                    </td>
                                    <td style="padding: 5px;">
                                        <select name="template"]]..buttonControl..[[ id="template">
]]
content = content .. templatesOptions
content = content .. [[
                                        </select>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Host address:</b>
                                    </td>
                                    <td style="padding: 5px;">
                                        <input type="text" name="host" value="]]..d.host..[["]]..inputControl..[[/>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Port:</b>
                                    </td>
                                    <td style="padding: 5px;">
                                        <input type="text" name="port" value="]]..d.port..[["]]..inputControl..[[/>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 5px;">
                                        <b>Slave:</b>
                                    </td>
                                    <td style="padding: 5px;">
                                        <input type="text" name="slave" value="]]..d.slave..[["]]..inputControl..[[/>
                                    </td>
                                </tr>
                            </table>
                            <br>
                            <hr>
                            <br>
]]
if (saved == 1) then
    if (createdNew == 1) then
        content = content .. [[
                            <b><img src="images/ok.png"/> Saved new device with serial ]]..d.serial..[[</b><br><br>
]]
    else
        content = content .. [[
                            <b><img src="images/ok.png"/> Changes saved.</b><br><br>
]]            
    end
end
content = content .. [[
                            <input type="hidden" name="file" value="]]..filename..[["/>
                            <input type="button" name="backButton" value="Back to Bus Configuration" onclick="window.location.assign('rsm_bus_config.lua');"/>
                            <input type="submit" name="saveButton" value="Save and Apply"]]..buttonControl..[[ onclick="doValidate = 1;"/>
]]
if (mode == "edit") then
    content = content .. [[
                            <input type="submit" name="deleteButton" value="Delete Device"]]..buttonControl..[[ onclick="return confirm('Are you sure you want to delete this device?');"/>
]]
end
content = content .. [[
                        </form>
                    </div>
]]    

if (mode == "edit") then
    cfg = cfg:gsub("<","&lt;")
    cfg = cfg:gsub(">","&gt;")
    content = content .. [[    
                    <script>
                        function toggleVis(target)
                        {
                            if (target.style.display == "none")
                            {
                                target.style.display = "inline-block";
                            }
                            else
                            {
                                target.style.display = "none";
                            }
                            return false;
                        }
                    </script>
                    <br><img src="images/magnify.png"/> <a href="javascript:void(0)" onclick="toggleVis(document.getElementById('filecfg'));">View ]]..modbusPath..[[/]]..filename..[[</a></a><br>
        
                    <div id="filecfg" style="display: none;">
                        <pre class="formLayoutfull">
]]..cfg..[[
                        </pre>
                    </div>    
]]
end

print(header..content..footer)
